package edu.calpoly.android.SimpleWidget;

import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.Context;
import android.content.Intent;
import android.widget.RemoteViews;

/**
 * This is the AppWidgetProvider wrapper class that will
 * help setup, maintain, and delete the home screen widget using
 * AppWidgetProvider's various call back methods. For this example,
 * we only override the onUpdate method to define the widget when it's 
 * first initiated.
 * 
 * @author Ken Hung
 */
public class SimpleWidgetProvider extends AppWidgetProvider {
	/**
	 * This method is called first right when the widget is first launched if no 
	 * configuration activity is specified.
	 */
	@Override
    public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
		// Number of IDs or the number of widgets opened
        final int N = appWidgetIds.length;

        // Perform this loop procedure for each App Widget that belongs to this provider
        // so if there are multiple instance of the widget open, we update all of them.
        for (int i=0; i<N; i++) {
        	/* TODO follow the instructions below. Each blank line represents the line
        	   of code to implement. */
        	
        	// Set an integer value equal to the ith index of appWidgetIds. This
        	// saves the current widget ID we're iterating on.

            // Create a new Intent to launch SimpleWidget Activity. Use the context
            // onUpdate's context parameter and SimpleWidget.class as parameters to this 
            // new Intent.

            // Create a new PendingIntent. Set it equal to a call to PendingIntent.getActivity.
            // Use onUpdate's context for the first parameter, 0 for the second parameter, the intent
            // we just make as the third and 0 for the last parameter.

            // Get the layout for the App Widget and attach an on-click listener to the button. To 
            // do that you need to Create a new RemoteView with the package name from the context 
            // passed by onUpdate and the layout for our widget (R.layout.simple_widget. To get the package 
            // name from the context, make a call to getPackageName() with the context from onUpdate's 
            // context parameter.

            // Have our new RemoteView call setOnClickPendingIntent with the first parameter specifying
            // the resource id for our widget button and the second parameter being the PendingIntent we 
            // just made.
            // This sets the click listener for the widget_button

            // Make a call to updateAppWidget with the appWidgetManager parameter from onUpdate.
            // Pass in the widget ID we saved at the beginning of the loop, and set the second
            // parameter to the RemoteViews we just created.
            // This tells the AppWidgetManager to perform an update on the current App Widget

        }
    }
}
